//
//  AppDelegate.m
//  DropSco
//
//  Created by Stanko Juzbasic on 3/19/15.
//  Copyright (c) 2015 Stanko Juzbasic. All rights reserved.
//
//______________________________________________________________________________________

#import "AppDelegate.h"
#include <libgen.h>

@implementation AppDelegate
@synthesize window;
@synthesize pathField;
//______________________________________________________________________________________
- (NSString*) readDefault: (NSString*)cmixPath
{
    NSString *val = [[NSUserDefaults standardUserDefaults] objectForKey:cmixPath];
    return val;
}
//______________________________________________________________________________________
- (void)dealloc
{
    [super dealloc];
}
//______________________________________________________________________________________
- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{

    [self.window setOpaque: NO];
    NSColor *semiTransparentDark =
            [NSColor colorWithDeviceRed:0.29 green:0.28 blue:0.33 alpha:0.89];
    [self.window setBackgroundColor:semiTransparentDark];
    [self.goButton setEnabled:NO];
    errorPipe = nil;
    versionMinor = 0;
    Gestalt(gestaltSystemVersionMinor, &(versionMinor));
    NSLog(@"Version Minor: %d\n", (int)(versionMinor));
    
}

//______________________________________________________________________________________
- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)sender
{
    if(tstate == suspended){
        [task terminate];
        tstate = notask;
    }
    return YES;
}
//_____________________________________________________________________________________
- (void)applicationWillTerminate:(NSNotification *)aNotification
{
    if(tstate == suspended){
        [task terminate];
        tstate = notask;
    }
}
//______________________________________________________________________________________
- (IBAction)go:(NSButton*)sender
{
    //NSLog(@"SCORE: %s\n", score);
    char cmd [1024];
    char dir [1024];
    char cpath [512];
    
    
    NSFileHandle *error;
    NSFileHandle *output;
    system("pwd\n");
    //cd to the score file directory to be able to load sound files
    //   from scorefile's viewpoint!!!
    
    if(strlen(score) < 2)return;
    
    NSString* cmixpath = [self readDefault:@"cmixPath"];
    NSLog(@"cmixPath = %@", cmixpath);

    strcpy(dir, "cd ");
    strcat(dir, dirname((char*)score));
    strcat(dir, " ; ");
    strcpy(cmd, dir);
    // if no user-made default, suggest for the default location
    if(cmixpath == nil){
    strcat(cmd, "/usr/local/bin/CMIX < ");
    cmixpath = [NSString stringWithFormat:@"/usr/local/bin/CMIX"];
    if([[NSFileManager defaultManager] isExecutableFileAtPath: cmixpath] != YES){
            NSLog(@"CMIX executable not found");
        [sender setState: 0];
        //post error sheet!!!
        return;
        }
    }else {
    if([cmixpath getCString: cpath maxLength:512 encoding:NSASCIIStringEncoding] == YES)
        strcat(cmd, cpath );
        strcat(cmd, " < ");
    }
    strcat(cmd, score);
    strcat(cmd, " &\n");
    //NSLog(@"COMMAND: %s\n", cmd);

    //NSLog(@"DIRNAME: %s\n",dir);
    
    NSString *argument = [NSString stringWithFormat: @"%s", score];
    
    //generic unix, old-style stuff - here just for testing - - - - - - - - - - - - - - -
    if(0){
    NSLog(@"ARGUMENT: %@\n", argument);
    
    system("pwd\n");

    system(cmd);
    
    char a[512];
    strcpy(a, " < ");
    strcat(a, score);
    }
    else
    {
    //OSX specific - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    //if sent a message: kill -STOP <tid> //and
    //                   kill -CONT <tid> //or their NSTask equivalents:
    //                   stderr posts a message:  'OSXAudioDevice: I/O thread overload!'
    //problem solved as of v. 0.3!
    // - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

    if([task isRunning]){
        //this is deprecated in OSX 10.10+, here just for checking
        NSLog(@"isRunning = %d\n",(int)[task isRunning]);
         };
        
    if (([[NSApp currentEvent] modifierFlags] & NSCommandKeyMask) != 0){
        if(tstate != notask){
        [task terminate];
        tstate = notask;
        [task release]; task = nil;
        [errorPipe release]; errorPipe = nil;
        [outputPipe release]; outputPipe = nil;
        tstate = notask;
        NSLog(@"taskTerminated\n");
        }
        [self.goButton setState: 0];
        [self.goButton setTitle: @">"];
        return;
    }
        
    if(tstate == running){
        [task suspend];
        tstate = suspended;
        [sender setTitle:@"||"];
        return;
        }
        
    if(tstate == suspended){
        [task resume];
        tstate = running;
        [sender setTitle: @">"];
        return;
        }
    
    
    outputPipe=[[NSPipe alloc]init];
    [task setStandardOutput:outputPipe];
    output=[outputPipe fileHandleForReading];
        
    /**/
    errorPipe=[[NSPipe alloc]init];
    [task setStandardError:errorPipe];        
    error=[errorPipe  fileHandleForReading];
    
    task = [[NSTask alloc] init];
        
    NSString *name = [NSString stringWithCString:score
                                        encoding:NSASCIIStringEncoding];
    NSFileHandle *stdin = [NSFileHandle fileHandleForReadingAtPath:name];
        
    [task setStandardInput:stdin];
    
    task.launchPath = [NSString stringWithFormat:@"%@", cmixpath];
    
    task.currentDirectoryPath = [NSString stringWithCString:dirname((char*)score)
                                                   encoding:NSASCIIStringEncoding];

        
   /**/
    if(1)
       [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(ReceivedError:)
                                                 name: NSFileHandleReadCompletionNotification
                                               object:error];
    if(1)        
        [[NSNotificationCenter defaultCenter] addObserver:self
                                                 selector:@selector(ReceivedOutput:)
                                                     name: NSFileHandleReadCompletionNotification
                                                   object:output];
   
    
    if(1){
        [[NSNotificationCenter defaultCenter] addObserver:self
                                                 selector:@selector(TaskCompletion:)
                                                     name: NSTaskDidTerminateNotification
                                                   object:task];
        tstate = running;
        }
    if(0)[task setStandardOutput:outputPipe];//we still don't use outputPipe
    
    [task setStandardError:errorPipe];
        
    [task launch];
        
    int tid = [task processIdentifier]; NSLog(@"TID = %d\n", tid);
        
    if(0)[output readInBackgroundAndNotify]; //we still don't use outputPipe
        
    [error readInBackgroundAndNotify];
        
    }
    // end OSX specific - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    NSLog(@"END\n");
}
//_______________________________________________________________________________________
-(void) ReceivedError : (NSNotification*) err_rec_not
{
    int i = 0;
    NSString* ignoreMsg = [self readDefault:@"ignoreMsg"];
    if(ignoreMsg != nil) i = 1;
    char *ignore = (char*)[ignoreMsg cStringUsingEncoding:NSASCIIStringEncoding];
    if(0)NSLog(@"ignoreMsg = %@\n", ignoreMsg);
    //char cString[] = {"OSXAudioDevice: I/O thread overload!"};
    //char cString[] = {"Hello, world!"};
    NSData *dataError=[[err_rec_not userInfo] objectForKey:NSFileHandleNotificationDataItem];
    NSString *message=[[NSString alloc] initWithData:dataError encoding:NSASCIIStringEncoding];
    const char *cmessage = [message cStringUsingEncoding:NSASCIIStringEncoding];
    if([message length] > 0){
        NSLog(@"ErrorMsg:%@.\n", message);
        //if(strncmp(cString,cmessage, 36) != 0){
            if(i){
                if((strstr(cmessage, ignore)== NULL))
                    [self mPostError:message];
                else ; //check for other messages clumped together with "ignoreMsg"                    
            }else [self mPostError:message];
        //}
    }
    [message release];
}
//_______________________________________________________________________________________

//_______________________________________________________________________________________
-(void) ReceivedOutput : (NSNotification*) out_rec_not
{
    NSData *dataOutput=[[out_rec_not userInfo] objectForKey:NSFileHandleNotificationDataItem];
    NSString *message=[[NSString alloc] initWithData:dataOutput encoding:NSASCIIStringEncoding];
    if([message length] > 0) NSLog(@"OutputMsg:%@.\n", message);

    [message release];
}
//_______________________________________________________________________________________
-(void) TaskCompletion :(NSNotification*) rec_not

{
    self.goButton.state = 0;
    [[self goButton] setTitle:@">"];
    [[self goButton] setEnabled:YES];
    tstate = notask;
   
    [task release]; task = nil;
    [errorPipe release]; errorPipe = nil;
    [outputPipe release]; outputPipe = nil;
    NSLog(@"COMPLETION\n");

}

//______________________________________________________________________________________
- (void)doKey
{
    NSLog(@"DOWN\n");
    if(tstate != notask){
        [task terminate];
        [task release]; task = nil;
        [errorPipe release]; errorPipe = nil;
        [outputPipe release]; outputPipe = nil;
        tstate = notask;
        [self.goButton setState: 0];
        [self.goButton setTitle: @">"];
    }
}
//___________________________________________________________
-(void)mDoSomething: (NSString*)cstr
{
    NSLog(@"%@",cstr);
}
//___________________________________________________________
-(void) mPostError:(NSString *)infoText
{
    char cMessage[64] = "CMIX Error:";
    NSString *message = [NSString stringWithCString:cMessage encoding:NSASCIIStringEncoding];
    NSAlert* mAlert = [[NSAlert alloc] init];
    [mAlert addButtonWithTitle:@"OK"];
    [mAlert setMessageText:message];
    [mAlert setInformativeText:infoText];
    [mAlert setAlertStyle: NSCriticalAlertStyle];
#if __MAC_OS_X_VERSION_MAX_ALLOWED > 1080
/**/
    if(versionMinor > 8){
        [mAlert beginSheetModalForWindow:self.window completionHandler:^(NSModalResponse returnCode) {
            [self mDoSomething: message];
        }];
    }else{

#endif
        [mAlert beginSheetModalForWindow:[self window]
                           modalDelegate:self
                          didEndSelector:@selector(alertDidEnd:returnCode:contextInfo:)
                             contextInfo:(void*)infoText];
#if __MAC_OS_X_VERSION_MAX_ALLOWED > 1080
    }
#endif
    
}
//___________________________________________________________

- (void)alertDidEnd:(NSAlert *)alert returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo
{
    /*
     The following options are deprecated in 10.9. Use NSAlertFirstButtonReturn instead
     NSAlertDefaultReturn = 1,
     NSAlertAlternateReturn = 0,
     NSAlertOtherReturn = -1,
     NSAlertErrorReturn = -2
     NSOKButton = 1, // NSModalResponseOK should be used
     NSCancelButton = 0 // NSModalResponseCancel should be used
     */
    if (returnCode == NSOKButton)
    {
        NSLog(@"(returnCode == NSOKButton)");
        //[self mDoSomething: cstr];
    }
    else if (returnCode == NSCancelButton)
    {
        NSLog(@"(returnCode == NSCancelButton)");
        //[self mDoSomething: cstr];
    }
    else if(returnCode == NSAlertFirstButtonReturn)
    {
        NSLog(@"if (returnCode == NSAlertFirstButtonReturn)");
        [self mDoSomething: (NSString*)contextInfo];
    }
    else if (returnCode == NSAlertSecondButtonReturn)
    {
        NSLog(@"else if (returnCode == NSAlertSecondButtonReturn)");
    }
    else if (returnCode == NSAlertThirdButtonReturn)
    {
        NSLog(@"else if (returnCode == NSAlertThirdButtonReturn)");
    }
    else
    {
        NSLog(@"All Other return code %ld",(long)returnCode);
    }
}
//________________________________________________________________________________________
/*
- (void)postSheet:(NSString *msg)
{
    if(versionMinor > 8){
        [self.window beginSheet:self.sheet completionHandler:^(NSInteger result) {
            if (result == 1) [self doSomething];
            if (result == 0) [self doNothing];
        }];
    }else
        [[NSApplication sharedApplication] beginSheet:self.sheet
                                       modalForWindow:self.window
                                        modalDelegate:self
                                       didEndSelector:@selector(sheetDidEnd:returnCode:contextInfo:)
                                          contextInfo:nil
         ];
}
//________________________________________________________________________________________
- (IBAction)ok:(id)sender
{
    [self.sheet orderOut:self];
    if(versionMinor > 8){NSLog(@">OK Button pressed\n");
        [self.window endSheet:self.sheet returnCode:1];
    }else{ NSLog(@"OK Button pressed\n");
        [NSApp endSheet:self.sheet returnCode: 1];
        
    }
}
//______________________________________________________________________________________
- (void)sheetDidEnd : (NSPanel*)panel
          returnCode:(NSInteger)returnCode
         contextInfo:(void*)contextInfo
{
//    if (returnCode == 1) [self doSomething ];
//    if (returnCode == 0) [self doNothing ];
    ;
}
*/
//______________________________________________________________________________________
- (void)quitIt
{
    ;
}
//______________________________________________________________________________________
@end
